'''
CS 1, Lecture 23

Recursive re-implementation of merge sort

'''

def merge(L1,L2):
    '''
    Merge the contents of two lists, each of which is already sorted
    into a single sorted list.
    '''
    i1 = 0
    i2 = 0
    L = []
    while i1 < len(L1) and i2 < len(L2):
        if L1[i1] < L2[i2]:
            L.append ( L1[i1] )
            i1 += 1
        else:
            L.append( L2[i2] )
            i2 += 1
    L.extend( L1[i1:] )
    L.extend( L2[i2:] )
    return(L)
            

def merge_sort(L):
    '''
    Implementation of the merge sort algorithm.
    Complexity: O(n logn)
    
    >>> merge_sort([5,4,3,2,1])
    [1, 2, 3, 4, 5]
    >>> merge_sort([1])
    [1]
    >>> merge_sort([1,2,3,4])
    [1, 2, 3, 4]
    >>> merge_sort([])
    []
    
    '''
    if len(L) <= 1:
        return (L)

    M = []
    for val in L:
        M.append( [val] )
    
    while len(M)>1:
        M2 = []
        for i in range(0,len(M)-1,2):
            M2.append( merge( M[i], M[i+1] ))
        if len(M)%2 == 1:
            M2.append(M[-1])
        M = M2
    return M[0]



def merge_sort_recursive(L):
    '''
    Implementation of the merge sort algorithm.
    Complexity: O(n logn)
    
    >>> merge_sort_recursive([5,4,3,2,1])
    [1, 2, 3, 4, 5]
    >>> merge_sort_recursive([1])
    [1]
    >>> merge_sort_recursive([1,2,3,4])
    [1, 2, 3, 4]
    >>> merge_sort([])
    []
    
    '''    
    if len(L) <= 1:
        return L
    else:
        mid = len(L)//2
        return merge( merge_sort_recursive(L[:mid]),
                      merge_sort_recursive(L[mid:]) )


def flatten(L):
    res = []
    for val in L:
        if type(val) != list:
            res.append(val)
        else:
            val_flattened = flatten(val)
            res.extend(val_flattened)
    return res

if __name__ == "__main__":
    pass   

